routes/web.php
<?php

Route::get('/', function () {
    return view('auth.login');
});


// Route::get('even', function () {
// 	    event(new \App\Events\NuevaOrdenEvent('MOOOOOOOOOOOOOOOOOOOOOOOY'));
// 	    //return "Event has been sent!";
// 		//dd(event(new \App\Events\NuevaOrdenEvent('hello world')));
// 	});

Route::post('ocr', 'OcrController@readImage');

Route::get('ocr/test', 'OcrController@test');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

// Route::get('auth/{provider}', 'Auth\SocialAuthController@redirectToProvider')->name('social.auth');
// Route::get('auth/{provider}/callback', 'Auth\SocialAuthController@handleProviderCallback');

Route::get('auth/google', 'Auth\GoogleController@redirectToGoogle');
Route::get('auth/google/callback', 'Auth\GoogleController@handleGoogleCallback');

Route::get('auth/facebook', 'Auth\FacebookController@redirectToFacebook');
Route::get('auth/facebook/callback', 'Auth\FacebookController@handleFacebookCallback');

Route::group(['middleware' => 'auth'], function(){

	Route::resource('roles', 'RoleController');
	Route::resource('permissions', 'PermissionsController');
	
	Route::group(['middleware' => ['Administrador']], function () {
		Route::resource('users', 'UsersController');
	});

	Route::resource('passwords', 'ReiniciarPasswordController');
	Route::resource('persona', 'PersonaController');

	Route::resource('archivo','ControllerArchivo');
	Route::resource('repositorio','ControllerRepositorioArchivo');
	Route::resource('comparar','ArchivoCompararController');
	
	Route::resource('categoriaproyectos','CategoriaProyectoController');
	Route::resource('proyectos','ProyectoController');
	Route::resource('asignacion','AsignacionController');
	Route::resource('gestionversiones','GestionVersionController');
	Route::resource('archivoproyecto','GestorArchivoController');
	Route::resource('usuariobloqueado','UserBloqueadoController');
	Route::resource('ocr', 'OcrController');
	Route::resource('redaccion', 'RedaccionController');
	Route::resource('plagionline', 'GoogleSearchController');
	
	

	//Roles
	Route::get('list_roles', 'RoleController@list_roles');
	Route::PUT('actualizarRoles/{criterio}', 'RoleController@actualizarRoles');
 
	//Usuario
	Route::get('/list_user', 'UsersController@list_user');
	Route::get('/bajaUsuario', 'UsersController@bajaUsuario');
	Route::get('/activarUsuario', 'UsersController@activarUsuario');
	
	Route::get('profile', 'UsersController@profile');
	Route::put('actualizardatos/{criterio}', 'UsersController@actualizardatos');

	Route::post('storePersonalizar','UsersController@storePersonalizar')->name('personalizar.store');
	Route::get('getPersonalizar','UsersController@getPersonalizar')->name('personalizar.show');
	
	Route::PUT('addRole/{criterio}/{role}','UsersController@addRole');
	//usuario bloqueado
	Route::get('/list_userbloqueado', 'UserBloqueadoController@list_userbloqueado');
	Route::get('/activarUsuarioBloqueado', 'UserBloqueadoController@activarUsuarioBloqueado');
	
	//ip bloqueo
	Route::get('/list_ipbloqueado', 'UserBloqueadoController@list_ipbloqueado');
	Route::post('/storeIp', 'UserBloqueadoController@storeIp')->name('blockip.store');
	Route::get('/activarIpBloqueado', 'UserBloqueadoController@activarIpBloqueado');
	
	//Persona
	Route::get('/listar_personas', 'PersonaController@listar_personas');
	Route::get('/get_allciudades', 'PersonaController@get_allciudades');
	Route::get('/get_usuariosdisponibles', 'PersonaController@get_usuariosdisponibles');
	
	Route::get('/get_allUsuarios', 'PersonaController@get_allUsuarios');
	Route::post('/actualizarPersonal/{id}', 'PersonaController@actualizarPersonal');


	//tipoarchivo
	Route::get('listar_tparchivos','ControllerArchivo@listar_tparchivos');
	Route::get('listar_extension','ControllerArchivo@listar_extension');
	Route::get('editExtension/{criterio}','ControllerArchivo@editExtension');
	Route::post('storeExtension','ControllerArchivo@storeExtension')->name('extension.store');
	Route::put('updateExtension/{criterio}','ControllerArchivo@updateExtension')->name('extension.update');
	Route::get('bajaExtension','ControllerArchivo@bajaExtension');
	Route::get('activarExtension','ControllerArchivo@activarExtension');
	Route::get('getArchivo','ControllerArchivo@getArchivo');

	//Repositorio
	Route::get('getExtensiones','ControllerRepositorioArchivo@getExtensiones');
	Route::get('getArchivo/{criterio}','ControllerRepositorioArchivo@getArchivo');
	Route::get('listar_repositorio','ControllerRepositorioArchivo@listar_repositorio');
	Route::post('actualizarrepositorio','ControllerRepositorioArchivo@actualizarrepositorio');

	//ArchivoComparar

	Route::get('listar_comparar','ArchivoCompararController@listar_comparar');
	Route::get('leerDocumento','ArchivoCompararController@leerDocumento');
	Route::get('convertirPDF','ArchivoCompararController@convertirPDF');
	Route::get('getArchivo2/{criterio}','ArchivoCompararController@getArchivo2');
	Route::get('getComparacion/{fileres}/{file}','ArchivoCompararController@getComparacion');

	//resultado
	Route::get('listar_resultados','ArchivoCompararController@listar_resultados');
	Route::get('resultadoIndex','ArchivoCompararController@resultadoIndex')->name('resultado.index');
	Route::get('getResultados','ArchivoCompararController@getResultados');

	//proyectos
	Route::get('listar_proyectos','ProyectoController@listar_proyectos');

	Route::get('estadoProyecto','ProyectoController@estadoProyecto');
	Route::get('getArchivoProyecto/{criterio}','ProyectoController@getArchivoProyecto');

	//Asignacion usuario
	Route::get('actualizarAsignacion','AsignacionController@actualizarAsignacion');
	Route::get('listar_asignacion','AsignacionController@listar_asignacion');

	//Gestor Archivos
	Route::get('listar_archivosp/{criterio}','ProyectoController@listar_archivosp');
	Route::get('getDocumento/{criterio}/{name}','GestorArchivoController@getDocumento');
	Route::get('listadoDirectorio/{id}/{criterio}/{ini}/{original}','GestorArchivoController@listadoDirectorio');
	
	Route::get('eliminarArchivo/{dir}/{dirhere}/','GestorArchivoController@eliminarArchivo');
	Route::get('leerDocumento2','GestorArchivoController@leerDocumento2');
	Route::get('listar_resultados2','GestorArchivoController@listar_resultados2');
	Route::get('resultadoproyecto','GestorArchivoController@resultadoproyecto')->name('resultadoproyecto.index');
	Route::get('getResultados2','GestorArchivoController@getResultados2');
	//categoria proyecto
	Route::get('listar_Categorias','CategoriaProyectoController@listar_Categorias');

	//gestionversiones
	Route::get('listar_Versiones/{criterio}','GestionVersionController@listar_Versiones');
	Route::get('getVersion/{criterio}','GestionVersionController@getVersion');
	Route::get('getCambios/{criterio}','GestionVersionController@getCambios');
	Route::delete('eliminarVersion','GestionVersionController@eliminarVersion');
	Route::get('getVersion2/{criterio}','GestionVersionController@getVersion2');


	//OCR
	Route::get('listar_ocr','OcrController@listar_ocr');
	Route::get('leerDocumentoOCR','OcrController@leerDocumentoOCR');
	Route::get('getArchivoOcr/{criterio}','OcrController@getArchivoOcr');
	Route::delete('eliminarArchivoOcr/{criterio}','OcrController@eliminarArchivoOcr');
	
	Route::get('recortarImagen','OcrController@recortarImagen');

	//Redaccion
	Route::get('listar_redacciones','RedaccionController@listar_redacciones');
	Route::get('veredaccion/{criterio}','RedaccionController@indexEditor');
	Route::get('getRedaccion/{criterio}','RedaccionController@getRedaccion');
	Route::post('guardarTexto','RedaccionController@guardarTexto');
	Route::delete('eliminarRedaccion/{criterio}','RedaccionController@eliminarRedaccion');
	Route::post('storeUsuario','RedaccionController@storeUsuario')->name('adduser.store');

	//api google
	Route::get('gerResultados/{contenido}', 'GoogleSearchController@gerResultados');
	Route::get('indexGoogleSearch/{contenido}', 'GoogleSearchController@indexGoogleSearch');
});

Route::get('clear-cache', function() {
    $exitCode = Artisan::call('config:clear');
    $exitCode = Artisan::call('cache:clear');
    $exitCode = Artisan::call('config:cache');
    
    return 'DONE';
}); ;
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/CategoriaProyecto.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CategoriaProyecto extends Model
{
    
    protected $table = "categoria_proyecto";

    protected $fillable = ['nombre'];
}

app/Http/Controllers/CategoriaProyectoController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\CategoriaProyecto;

use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use DataTables;
use Illuminate\Support\Facades\Auth;

use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
class CategoriaProyectoController extends Controller
{
    function __construct()
    {
        $this->middleware('permission:CategoriaProyecto-list|CategoriaProyecto-create|CategoriaProyecto-edit', ['only' => ['index','store']]);
        $this->middleware('permission:CategoriaProyecto-create', ['only' => ['create','store']]);
        $this->middleware('permission:CategoriaProyecto-edit', ['only' => ['edit','update']]);
    }

    public function index()
    {
        return view('admin.categoriaproyecto.index');
    }

    public function create()
    {
        //
    }

    public function store(Request $request)
    {
        if($request->ajax())
        {
            $CategoriaProyecto = new CategoriaProyecto($request->all());
            $CategoriaProyecto->save();

            return response()->json($CategoriaProyecto);
        }
    }

    public function listar_Categorias()
    {
        $proyecto =  DB::table('categoria_proyecto')->get();
        if(request()->ajax()){
            return Datatables::of($proyecto)
                ->rawColumns( ['id','nombre','username','created_at'])
                ->make(true);
        }else{
            abort('404');
        }
    }

    public function show($id)
    {
        
    }

    public function edit($id)
    {
        return CategoriaProyecto::find($id);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $dato = CategoriaProyecto::find($id);
        $dato->nombre = $request->nombre;
        $dato->save();
        return response()->json($dato);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/admin/categoriaproyecto/index.blade.php
@extends('template.app')

@section('title','Lista de Categoria Proyecto')
@section('main-content')
   <!-- Your Page Content Here -->
    <!-- if(Auth::user()->role->permission->add == 1) -->
    @if(Auth::user()->hasPermissionTo('CategoriaProyecto-create'))
        <div align="left" style="border:auto;">
            <button type="button" class="btn btn-info"  data-toggle="modal" data-target="#modal-RCategoria">
                Nueva Categoria
            </button>
        </div>
    @endif
    <!-- endif -->
    <hr>
    <div class="table-responsive table-striped">
        <table id="Tabla-Categorias" class="table table-bordered table-striped" width="100%">
            <thead > 
                <tr>
                    <th style="text-align: center;" >#</th>
                    <th style="text-align: center;" >Nombre</th>
                    <th style="text-align: center;" >Accion</th>
                </tr> 
            </thead>
            <tbody style="text-align: center;">

            </tbody>
        </table>
    </div>  
 
    @include('admin.categoriaproyecto.modal-crear')
    @include('admin.categoriaproyecto.modal-editar')

@endsection
@section('js')
<script type="text/javascript">
    $( document ).ready(function() {
        activar_tabla_categorias();
        cambio();
    });

    $( document ).ajaxStop(function() {
        //preloader();
    });


    function activar_tabla_categorias() {
        var t = $('#Tabla-Categorias').DataTable({
            "processing"  : true,
            "serverSide"  : true,
            "searchDelay" : 500 ,
            "lengthMenu": [5,10, 25, 50, 75 ],
            "responsive": true,
            "language": {
            "url": '{!! asset('/plugins/datatables.net/latino.json') !!}',
            },
            "ajax":'{!! url('listar_Categorias') !!}',
            columns: [
                {data: 'id' },
                {data: 'nombre' },
                {
                "defaultContent" : " ",
                "searchable" : false,
                "orderable" : false,
                "render" : function(data, type, row, meta) {
                    var html='<div class="form-group" >';
                    var edit = "{{Auth::user()->hasPermissionTo('CategoriaProyecto-edit') }}";
                    if(edit !='')                   
                        html+='<a style="width:100px; margin:5px;" data-toggle="modal" data-target="#modal-ECategoria" class="btn btn-warning btn-xs text-white" onclick="llenarDatosEdit('+row.id+');"><i class="fas fa-wrench"></i> Editar </a> </br>';
                   
                    html +="</div>";
                    return html;
                },
            }]
        });
        t.on( 'draw.dt', function () {
            var PageInfo = $('#Tabla-Categorias').DataTable().page.info();
                 t.column(0, { page: 'current' }).nodes().each( function (cell, i) {
                    cell.innerHTML = i + 1 + PageInfo.start;
                } );
            } );
    }

    function llenarDatosEdit(criterio)
    {
        var route = "{{url('categoriaproyectos')}}/"+criterio+"/edit";
        $.get(route, function(data){      
            
            $(".idCategoria").val(data.id);
            $("#Ecategoria").val(data.nombre);
            //$(".titleRole").html("Actualiando ROL");
        });
    }

    $("#btnRCategoria").click(function(e){
        var registerForm = $("#FRCategoria");
        var formData = registerForm.serialize();

        var route = "{{route('categoriaproyectos.store')}}";
        var token = $("input[name=_token]").val();
        $.ajax({ 
            url : route,
            headers: {'X-CSRF-TOKEN': token},
            type: 'POST',
            dataType: 'json',
            data:formData,
            success : function(data){
                $("#modal-RCategoria").modal("toggle");
                toastr.success("Categoria Registrada.");  
                $('#Tabla-Categorias').DataTable().ajax.reload();
            }
        });
 
    });

    $("#btnECategoria").click(function(e){
        var criterio = $(".idCategoria").val();
        var nombre = $("#Ecategoria").val();
        var route = "{{url('categoriaproyectos')}}/"+criterio;
        var token = $("input[name=_token]").val();
        $.ajax({
            url : route,
            headers: {'X-CSRF-TOKEN': token},
            type: 'PUT',
            dataType: 'json',
            data:{nombre},
            success : function(data){
                $("#modal-ECategoria").modal("toggle");
                toastr.success("Categoria Actualizada.");  
                $('#Tabla-Categorias').DataTable().ajax.reload();
            }
        });

    });

    function cambio (){
        var route = "{{url('getPersonalizar')}}"
        var token = $("input[name=_token]").val();
        $.ajax({
            url : route,
            headers : {'X-CSRF-TOKEN':token},
            method : 'get',
            //dataType : 'json',
            //data : estiloGlobal,
            success : function (data)
            {
                for (var i = 0; i < data.length; i++) {
                if(data[i].nav_type != null)
                    $(".pcoded").attr("nav-type", data[i].nav_type);
                if(data[i].navbar_logo != null) 
                    $(".navbar-logo").attr("logo-theme", data[i].navbar_logo)
                if(data[i].pcoded_navigatio_lavel != null)
                    $(".pcoded-navigatio-lavel").attr("menu-title-theme", data[i].pcoded_navigatio_lavel)
                if(data[i].pcoded_header != null)
                    $(".pcoded-header").attr("header-theme", data[i].pcoded_header)
                if(data[i].pcoded_navbar != null)                        
                    $(".pcoded-navbar").attr("navbar-theme", data[i].pcoded_navbar)
                if(data[i].active_item_them != null)
                    $(".pcoded-navbar").attr("active-item-theme", data[i].active_item_them)
                if(data[i].sub_item_theme != null)
                    $(".pcoded-navbar").attr("sub-item-theme", data[i].sub_item_theme)
                if(data[i].themebg_pattern != null)
                    $("body").attr("themebg-pattern", data[i].themebg_pattern)
                if(data[i].vertical_effect != null)
                    $(".pcoded").attr("vertical-effect", data[i].vertical_effect)
                if(data[i].item_border_style != null)
                    $(".pcoded-navbar .pcoded-item").attr("item-border-style", data[i].item_border_style)
                if(data[i].dropdown_icon != null)
                    $(".pcoded-navbar .pcoded-hasmenu").attr("dropdown-icon", data[i].dropdown_icon)
                if(data[i].subitem_icon != null)
                    $(".pcoded-navbar .pcoded-hasmenu").attr("subitem-icon", data[i].subitem_icon)
                var usuario = '{{Auth::user()->id}}';
                if(data[i].imagen != null)
                {
                    var url = 'personalizado/user/'+usuario+'/'+data[i].imagen;
                    $('head').append('<style>.main-menu:before{content: ""; background-image: url('+url+'); background-size: cover; position: absolute; top: 0px; right: 0px; bottom: 0px; left: 0px; opacity: 0.2;}</style>');
                    
                }
                }
                
            },
            error : function (data){
                toastr.error("ERROR");
            }
        })
    };
    </script>

@endsection

resources/views/admin/categoriaproyecto/modal-crear.blade.php
<div class="modal fade" id="modal-RCategoria" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
	<div class="modal-dialog ">
		{!! Form::open(['id'=> 'FRCategoria','autocomplete' => 'off']) !!}
		<div class="modal-content">
		  	<div class="modal-header bg-primary">
		    	<h5 class="modal-title titleRole" >Formulario - Nueva Categoria</h5>
			    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
			      	<span aria-hidden="true">&times;</span>
			    </button>
		  	</div>
		  	<div class="modal-body">
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
						{!! Form::label('categoria','Categoria') !!}
						{!! Form::text( 
							'nombre',null,
							['class'=>'form-control',
							'placeholder' =>'Nombre Categoria',
							'id'=>'Rcategoria']) !!}
						</div>
					</div> 
				</div>
		  	</div>
		  	<div class="modal-footer">
			    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
			    {!!link_to('#', $title='Registrar', $attributes = ['id'=>'btnRCategoria', 'class'=>'btn btn-primary'])!!}
		  	</div>
		</div>
		{!! Form::close() !!}
	</div>
</div>

resources/views/admin/categoriaproyecto/modal-editar.blade.php
<div class="modal fade" id="modal-ECategoria" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
	<div class="modal-dialog ">
		{!! Form::open(['id'=> 'FRECategoria','autocomplete' => 'off']) !!}
		<div class="modal-content">
		  	<div class="modal-header bg-primary">
		    	<h5 class="modal-title titleRole" >Formulario - Actualizar Categoria</h5>
			    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
			      	<span aria-hidden="true">&times;</span>
			    </button>
		  	</div>
		  	<input type="hidden" class="idCategoria" value="">
		  	<div class="modal-body">
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
						{!! Form::label('categoria','Categoria') !!}
						{!! Form::text( 
							'nombre',null,
							['class'=>'form-control',
							'placeholder' =>'Nombre Categoria',
							'id'=>'Ecategoria']) !!}
						</div>
					</div> 
				</div>
		  	</div>
		  	<div class="modal-footer">
			    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
			    {!!link_to('#', $title='Actualizar', $attributes = ['id'=>'btnECategoria', 'class'=>'btn btn-primary'])!!}
		  	</div>
		</div>
		{!! Form::close() !!}
	</div>
</div>